<template>
  <i-wrapper top :growable="false">
    <i-header :title="$t(`Support`)" back />
    <div ref="content" class="content">
      <div ref="messages" class="messages">
        <div
          v-for="message in messages"
          :key="message.id"
          class="message"
          :class="{ 'message--left': message.side === 'left', 'message--right': message.side === 'right' }">
          <span class="message__wrapper">{{ message.text }}</span>
        </div>
      </div>
      <div class="options options--shown">
        <button v-for="option in textOptions" :key="option.id" class="option" @click="option.callback(option.text)">
          {{ option.text }}
        </button>
        <form
          v-if="customOption"
          class="new-message"
          :key="customOption.id"
          @submit.prevent="customOption.callback(newMessage.text)">
          <input
            ref="newMessageInput"
            v-model="newMessage.text"
            class="new-message__input"
            :placeholder="customOption.placeholder" />
          <button
            type="submit"
            class="new-message__send"
            :class="{ 'new-message__send--loading': newMessage.isLoading }"
            :disabled="newMessage.isLoading" />
        </form>
      </div>
    </div>
  </i-wrapper>
</template>

<script>
  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],

    data() {
      return {
        questions: [
          {
            id: 1,
            text: 'How can I help you today? Please choose category of your question.',
            answers: [{ text: 'Subscription and Billing', nextQuestionId: 2 }],
          },
          {
            id: 2,
            text: 'How can I help you with your subscription?',
            answers: [{ text: 'I want to cancel my subscription', nextQuestionId: 3 }],
          },
          {
            id: 3,
            text: 'How did you subscribe?',
            answers: [
              { text: 'Google Play', nextQuestionId: 4 },
              { text: 'Apple Store', nextQuestionId: 4 },
              { text: 'Credit Card', nextQuestionId: 4 },
              { text: 'PayPal, or Apple Pay', nextQuestionId: 4 },
              { text: "I don't know", nextQuestionId: 4 },
            ],
          },
          {
            id: 4,
            text: 'What is your email address?',
            answers: [{ placeholder: 'Type your email address', nextQuestionId: 5 }],
            onAnswer: async (text) => {
              await this.$axios.post(`users/me/subscription/want_to_cancel`, {
                email: text,
              });
            },
          },
          {
            id: 5,
            text: 'Thank you, you will be automatically unsubscribed in next 24 hours.',
            answers: [],
          },
        ],
        messages: [
          // {
          //   id: 1,
          //   side: 'left',
          //   text: '',
          // },
        ],
        options: [
          // {
          //   id: 1,
          //   text: "",
          //   callback: "",
          // },
        ],
        newMessage: {
          isLoading: false,
          text: null,
        },
      };
    },

    computed: {
      textOptions() {
        return this.options.filter((option) => option.text);
      },

      customOption() {
        return this.options.find((option) => !option.text) || null;
      },
    },

    mounted() {
      //
      this.askQuestion(1);
      this.scrollToBottom();
    },

    methods: {
      getQuestionById(questionId) {
        return this.questions.find((question) => question.id === questionId) || null;
      },

      addMessage({ text, side }) {
        this.messages.push({
          id: this.messages.length + 1,
          text,
          side,
        });
      },

      showOptions(options) {
        this.options = options.map((option, optionIndex) => {
          return {
            id: optionIndex + 1,
            text: option.text,
            placeholder: option.placeholder,
            callback: option.callback,
          };
        });

        if (this.options.find((option) => !option.text)) {
          setTimeout(() => {
            this.$refs.newMessageInput.focus();
          }, 250);
        }
      },

      scrollToBottom() {
        this.$nextTick(() => {
          let nuxtElement = document.querySelector('#__nuxt');
          nuxtElement.scrollTop = nuxtElement.scrollHeight;
        });
      },

      askQuestion(questionId) {
        let question = this.getQuestionById(questionId);
        this.addMessage({ text: question.text, side: 'left' });

        this.showOptions(
          question.answers.map((answer) => {
            return {
              text: answer.text || null,
              placeholder: answer.placeholder || null,
              callback: async (text) => {
                if (question.onAnswer) {
                  this.newMessage.isLoading = true;

                  try {
                    await question.onAnswer(text);
                    this.newMessage.isLoading = false;
                  } catch (error) {
                    this.newMessage.isLoading = false;
                    throw error;
                  }
                }

                this.addMessage({ text, side: 'right' });
                this.askQuestion(answer.nextQuestionId);
                this.scrollToBottom();
              },
            };
          })
        );
      },
    },
  };
</script>

<style lang="scss" scoped>
  .content {
    width: 100%;
  }

  .messages {
    width: 100%;
    min-height: 100%;
    padding: rs(10px);
    flex: 1 1 auto;
    overflow-y: auto;
  }

  .message {
    display: flex;
    width: 100%;

    &--left {
      justify-content: flex-start;
    }

    &--right {
      justify-content: flex-end;
    }

    &:not(:first-child) {
      margin-top: rs(5px);
    }
  }

  .message__wrapper {
    background-color: #fff;
    font-size: rf(14px);
    padding: rs(8px);
    // border: rs(2px) solid #524c62;
    box-shadow: 0 5px 10px rgba(0, 0, 0, 0.15);
    border-radius: rs(15px);
  }

  .message--left .message__wrapper {
    border-top-left-radius: 0;
  }

  .message--right .message__wrapper {
    border-bottom-right-radius: 0;
  }

  .options {
    display: flex;
    flex-wrap: wrap;
    justify-content: flex-end;
    padding-right: rs(10px);
    padding-bottom: rs(10px);
    opacity: 1;
    visibility: visible;
    max-height: 300px;
    transition: opacity 0.2s, visibility 0.2s, max-height 0.2s;
  }

  .options:not(.options--shown) {
    opacity: 0;
    visibility: hidden;
    max-height: 0;
  }

  .option {
    font-size: rf(14px);
    padding: rs(10px);
    background-color: #fff;
    border: rs(1px) solid #524c62;
    border-radius: rs(15px);
    border-bottom-right-radius: 0;
    box-shadow: 0 5px 10px rgba(0, 0, 0, 0.15);
    cursor: pointer;
    margin-left: rs(10px);
    margin-top: rs(10px);
  }

  .new-message {
    display: flex;
    width: 100%;
    margin-left: rs(10px);
    margin-top: rs(10px);
  }

  .new-message__input {
    flex-grow: 1;
    padding: rs(10px);
    border: rs(1px) solid #524c62;
    outline: none;
    resize: none;
    font-family: inherit;
    font-size: rf(14px);
    border-top-left-radius: rs(16px);
    border-bottom-left-radius: rs(16px);
    line-height: rs(16px);
    box-sizing: border-box;
  }

  .new-message__send {
    width: rs(36px);
    border: rs(1px) solid #524c62;
    border-left: 0;
    border-top-right-radius: rs(16px);
    background-image: url('~assets/images/send-message.svg');
    background-repeat: no-repeat;
    background-color: #fff;
    background-size: rs(20px);
    background-position: center;
    cursor: pointer;
    box-shadow: 0 -5px 10px rgba(0, 0, 0, 0.15);
  }

  .new-message__send--loading {
    background-image: url('~assets/images/spinner-black.svg');
  }
</style>
